;===========================================================================================
; Iconin.asm  GoAsm assembler
; Charger un fichier d'icone binaire en mmoire et l'afficher  l'cran
; L'icone est intgre dans l'.exe qui est autonome.
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\iconin.rc
; ..\..\bin\GoAsm iconin.asm
; ..\..\bin\GoLink iconin.obj res\iconin.res user32.dll kernel32.dll gdi32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE  = 17

  ICON_SIZE = 744                  ;taille de Icon.ico (header=22 Image=744) total=766

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne spcifique
    ; ---------------------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur systme
    ; -------------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fenetre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,0,addr ClassName,addr Titre,WS_CAPTION+WS_POPUP+WS_SYSMENU \
                         +WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affiche et rafraichit la fenetre
    ; --------------------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWnd]

 ; Boucle des messages
 ; -------------------
 MessageLoop:
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmcreate
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande fin d'application
        ; -------------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmcreate:
    cmp D[@uMsg],WM_CREATE
    jne >.wmpaint
        ; Cration d'une icone(ou curseur) d'aprs les datas d'une ressource
        ; ------------------------------------------------------------------
        invoke CreateIconFromResource,addr ptIcon,ICON_SIZE,-1,030000h
        mov [hIcon],eax
        jmp >.exit

    .wmpaint:
    cmp D[@uMsg],WM_PAINT
    jne >.defwindowproc
        ; Dbut dessin/criture
        ; ---------------------
        invoke BeginPaint,[@hWnd],addr ps
        mov [ps.hdc],eax

        ; Affiche une icone
        ; -----------------
        invoke DrawIcon,[ps.hdc],134,68,[hIcon]

        ; Fin dessin/criture
        ; -------------------
        invoke EndPaint,[@hWnd],addr ps
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; ------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:

    mov eax,0
    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  ptIcon INCBIN res\icon.ico, 22                     ;sauter le header du fichier d'icone
  Titre     db ' Icne datas binaire' ,0
  ClassName db ' AsmGges Win32',0
  MsgEnd    db ' GoAsm AsmGges France @2006  ',0
  align 4

  WinX      dd 0
  WinY      dd 100
  WinW      dd 300
  WinH      dd 200

  hWnd      dd ?
  hIcon     dd ?

  msg       MSG         <>
  wc        WNDCLASS    < 0, addr WindowProc, 0, 0, NULL, NULL, NULL,\
                          COLOR_WINDOW+1, NULL, addr ClassName >
  ps        PAINTSTRUCT <>

;===========================================================================================
